diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java b/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java
index 8ec82d0a42c0faa19ef551b4a9b172c57a4db6e8..e580cc9a453b40a93655fa48e0c16be239067c83 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/QueryReq.java
@@ -437,19 +437,19 @@ public class QueryReq extends CMSServlet {
 
             int numEntries = list.getSize() - list.getCurrentIndex();
 
-            Vector v = fetchRecords(list, maxCount);
+            Vector<IRequest> v = fetchRecords(list, maxCount);
             v = normalizeOrder(v);
             trim(v, id);
 
             int currentCount = 0;
             BigInteger curNum = BigInteger.ZERO;
             BigInteger firstNum = BigInteger.ONE.negate();
-            Enumeration requests = v.elements();
+            Enumeration<IRequest> requests = v.elements();
 
             while (requests.hasMoreElements()) {
                 IRequest request = null;
                 try {
-                    request = (IRequest) requests.nextElement();
+                    request = requests.nextElement();
                 } catch (Exception e) {
                     CMS.debug("Error displaying request:" + e.getMessage());
                     // handled below
@@ -493,9 +493,9 @@ public class QueryReq extends CMSServlet {
      * @param v The vector to trim
      * @param marker the marker to look for.
      */
-    private void trim(Vector v, RequestId marker) {
+    private void trim(Vector<IRequest> v, RequestId marker) {
         int i = v.size() - 1;
-        if (((IRequest) v.elementAt(i)).getRequestId().toString().equals(
+        if (v.elementAt(i).getRequestId().toString().equals(
                 marker.toString())) {
             v.remove(i);
         }
@@ -508,9 +508,9 @@ public class QueryReq extends CMSServlet {
      * @param list
      * @return
      */
-    private Vector fetchRecords(IRequestVirtualList list, int maxCount) {
+    private Vector<IRequest> fetchRecords(IRequestVirtualList list, int maxCount) {
 
-        Vector v = new Vector();
+        Vector<IRequest> v = new Vector<IRequest>();
         int count = list.getSize();
         int c = 0;
         for (int i = 0; i < count; i++) {
@@ -533,20 +533,20 @@ public class QueryReq extends CMSServlet {
      * @param list
      * @return
      */
-    private Vector normalizeOrder(Vector list) {
+    private Vector<IRequest> normalizeOrder(Vector<IRequest> list) {
 
-        BigInteger firstrequestnum = new BigInteger(((IRequest) list.elementAt(0))
+        BigInteger firstrequestnum = new BigInteger(list.elementAt(0)
                 .getRequestId().toString());
-        BigInteger lastrequestnum = new BigInteger(((IRequest) list.elementAt(list
-                .size() - 1)).getRequestId().toString());
+        BigInteger lastrequestnum = new BigInteger(list.elementAt(list
+                .size() - 1).getRequestId().toString());
         boolean reverse = false;
         if (firstrequestnum.compareTo(lastrequestnum) > 0) {
             reverse = true; // if the order is backwards, place items at the beginning
         }
-        Vector v = new Vector();
+        Vector<IRequest> v = new Vector<IRequest>();
         int count = list.size();
         for (int i = 0; i < count; i++) {
-            Object request = list.elementAt(i);
+            IRequest request = list.elementAt(i);
             if (request != null) {
                 if (reverse)
                     v.add(0, request);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/wizard/WizardServlet.java b/pki/base/common/src/com/netscape/cms/servlet/wizard/WizardServlet.java
index bc4ab990b2824b0bcc94ca36e6d912fbc3e5c1ba..a71f26dcfa01f594cc40661a726e1e8286dd70e9 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/wizard/WizardServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/wizard/WizardServlet.java
@@ -52,7 +52,7 @@ public class WizardServlet extends VelocityServlet {
      */
     private static final long serialVersionUID = -4513510177445656799L;
     private String name = null;
-    private Vector mPanels = new Vector();
+    private Vector<IWizardPanel> mPanels = new Vector<IWizardPanel>();
 
     public void init(ServletConfig config) throws ServletException {
         super.init(config);
@@ -84,8 +84,8 @@ public class WizardServlet extends VelocityServlet {
     public void exposePanels(HttpServletRequest request,
                             HttpServletResponse response,
                             Context context) {
-        Enumeration e = mPanels.elements();
-        Vector panels = new Vector();
+        Enumeration<IWizardPanel> e = mPanels.elements();
+        Vector<IWizardPanel> panels = new Vector<IWizardPanel>();
         while (e.hasMoreElements()) {
             IWizardPanel p = (IWizardPanel) e.nextElement();
             panels.addElement(p);
@@ -106,7 +106,7 @@ public class WizardServlet extends VelocityServlet {
     }
 
     public IWizardPanel getPanelByNo(int p) {
-        IWizardPanel panel = (IWizardPanel) mPanels.elementAt(p);
+        IWizardPanel panel = mPanels.elementAt(p);
         if (panel.shouldSkip()) {
             panel = getPanelByNo(p + 1);
         }
@@ -153,8 +153,8 @@ public class WizardServlet extends VelocityServlet {
             ret += ((Integer) v).toString();
         } else if (v instanceof Vector) {
             ret += "<Vector>";
-            Vector v1 = (Vector) v;
-            Enumeration e = v1.elements();
+            Vector<?> v1 = (Vector<?>) v;
+            Enumeration<?> e = v1.elements();
             StringBuffer sb = new StringBuffer();
             while (e.hasMoreElements()) {
                 sb.append(xml_value_flatten(e.nextElement()));
@@ -227,7 +227,7 @@ public class WizardServlet extends VelocityServlet {
         if (request.getParameter("panelname") != null) {
             String name = request.getParameter("panelname");
             for (int i = 0; i < mPanels.size(); i++) {
-                IWizardPanel panel = (IWizardPanel) mPanels.elementAt(i);
+                IWizardPanel panel = mPanels.elementAt(i);
                 if (panel.getId().equals(name)) {
                     return i;
                 }
@@ -239,19 +239,18 @@ public class WizardServlet extends VelocityServlet {
     }
 
     public String getNameFromPanelNo(int p) {
-        IWizardPanel wp = (IWizardPanel) mPanels.elementAt(p);
+        IWizardPanel wp = mPanels.elementAt(p);
         return wp.getId();
     }
 
     public IWizardPanel getPreviousPanel(int p) {
         CMS.debug("getPreviousPanel input p=" + p);
-        IWizardPanel backpanel = (IWizardPanel) mPanels.elementAt(p - 1);
+        IWizardPanel backpanel = mPanels.elementAt(p - 1);
         if (backpanel.isSubPanel()) {
-            backpanel = (IWizardPanel) mPanels.elementAt(p - 1 - 1);
+            backpanel = mPanels.elementAt(p - 1 - 1);
         }
         while (backpanel.shouldSkip()) {
-            backpanel = (IWizardPanel)
-                         mPanels.elementAt(backpanel.getPanelNo() - 1);
+            backpanel = mPanels.elementAt(backpanel.getPanelNo() - 1);
         }
         CMS.debug("getPreviousPanel output p=" + backpanel.getPanelNo());
         return backpanel;
@@ -259,9 +258,9 @@ public class WizardServlet extends VelocityServlet {
 
     public IWizardPanel getNextPanel(int p) {
         CMS.debug("getNextPanel input p=" + p);
-        IWizardPanel panel = (IWizardPanel) mPanels.elementAt(p);
+        IWizardPanel panel = mPanels.elementAt(p);
         if (p == (mPanels.size() - 1)) {
-            p = p;
+            // p = p;
         } else if (panel.isSubPanel()) {
             if (panel.isLoopbackPanel()) {
                 p = p - 1; // Login Panel is a loop back panel
@@ -303,7 +302,7 @@ public class WizardServlet extends VelocityServlet {
         else
             CMS.debug("WizardServlet: in next " + p);
 
-        IWizardPanel panel = (IWizardPanel) mPanels.elementAt(p);
+        IWizardPanel panel = mPanels.elementAt(p);
         try {
             panel.validate(request, response, context);
             try {
@@ -419,9 +418,9 @@ public class WizardServlet extends VelocityServlet {
 
     public void outputHttpParameters(HttpServletRequest httpReq) {
         CMS.debug("WizardServlet:service() uri = " + httpReq.getRequestURI());
-        Enumeration paramNames = httpReq.getParameterNames();
+        Enumeration<String> paramNames = httpReq.getParameterNames();
         while (paramNames.hasMoreElements()) {
-            String pn = (String) paramNames.nextElement();
+            String pn = paramNames.nextElement();
             // added this facility so that password can be hidden,
             // all sensitive parameters should be prefixed with 
             // __ (double underscores); however, in the event that
diff --git a/pki/base/common/src/com/netscape/cmscore/cert/X500NameSubsystem.java b/pki/base/common/src/com/netscape/cmscore/cert/X500NameSubsystem.java
index 4f6d6c63288dddd45d63357633779f5a6b5d2e6c..89a22921662cfe4e157f44ffacf346c53c0bf582 100644
--- a/pki/base/common/src/com/netscape/cmscore/cert/X500NameSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/cert/X500NameSubsystem.java
@@ -154,7 +154,7 @@ public class X500NameSubsystem implements ISubsystem {
             throws EBaseException {
         X500NameAttrMap globalMap = X500NameAttrMap.getDefault();
         IConfigStore attrSubStore = mConfig.getSubStore(PROP_ATTR);
-        Enumeration attrNames = attrSubStore.getSubStoreNames();
+        Enumeration<String> attrNames = attrSubStore.getSubStoreNames();
 
         while (attrNames.hasMoreElements()) {
             String name = (String) attrNames.nextElement();
diff --git a/pki/base/common/src/com/netscape/cmscore/connector/RequestTransfer.java b/pki/base/common/src/com/netscape/cmscore/connector/RequestTransfer.java
index c00d5c8b5debade7daaa4bc3802e6812b0d1356d..33a2d7d7138b37ae1786796d64bac37bb5930527 100644
--- a/pki/base/common/src/com/netscape/cmscore/connector/RequestTransfer.java
+++ b/pki/base/common/src/com/netscape/cmscore/connector/RequestTransfer.java
@@ -71,11 +71,11 @@ public class RequestTransfer {
             // copy everything in the request
             CMS.debug("RequestTransfer: profile request " +
                     r.getRequestId().toString());
-            Enumeration e = r.getExtDataKeys();
-            Vector v = new Vector();
+            Enumeration<String> e = r.getExtDataKeys();
+            Vector<String> v = new Vector<String>();
 
             while (e.hasMoreElements()) {
-                String k = (String) e.nextElement();
+                String k = e.nextElement();
 
                 if (k.equals("requestType"))
                     continue;
diff --git a/pki/base/common/src/com/netscape/cmscore/connector/Resender.java b/pki/base/common/src/com/netscape/cmscore/connector/Resender.java
index edef41b8c6c10653930c7bb6a310b06b387534cd..783caa6710a13f29514513485cf9340a7275fdc7 100644
--- a/pki/base/common/src/com/netscape/cmscore/connector/Resender.java
+++ b/pki/base/common/src/com/netscape/cmscore/connector/Resender.java
@@ -50,7 +50,7 @@ public class Resender implements IResender {
     protected IRemoteAuthority mDest = null;
 
     /* Vector of Request Id *Strings* */
-    protected Vector mRequestIds = new Vector();
+    protected Vector<String> mRequestIds = new Vector<String>();
 
     protected HttpConnection mConn = null;
 
@@ -130,15 +130,16 @@ public class Resender implements IResender {
 
     private void resend() {
         // clone a seperate list so mRequestIds can be modified
-        Vector rids = (Vector) mRequestIds.clone();
-        Vector completedRids = new Vector();
+        @SuppressWarnings("unchecked")
+        Vector<String> rids = (Vector<String>) mRequestIds.clone();
+        Vector<RequestId> completedRids = new Vector<RequestId>();
 
         // resend each request to CA to ping for status.
-        Enumeration enum1 = rids.elements();
+        Enumeration<String> enum1 = rids.elements();
 
         while (enum1.hasMoreElements()) {
             // request ids are added as strings.
-            String ridString = (String) enum1.nextElement();
+            String ridString = enum1.nextElement();
             RequestId rid = new RequestId(ridString);
             IRequest r = null;
 
@@ -181,11 +182,11 @@ public class Resender implements IResender {
         }
 
         // remove completed ones from list so they won't be resent.
-        Enumeration en = completedRids.elements();
+        Enumeration<RequestId> en = completedRids.elements();
 
         synchronized (mRequestIds) {
             while (en.hasMoreElements()) {
-                RequestId id = (RequestId) en.nextElement();
+                RequestId id = en.nextElement();
 
                 CMS.debug(
                         "Connector: Removed request " + id + " from re-send queue");
@@ -200,7 +201,6 @@ public class Resender implements IResender {
     // this is almost the same as connector's send.
     private boolean send(IRequest r)
             throws IOException, EBaseException {
-        IRequest reply = null;
 
         try {
             HttpPKIMessage tomsg = new HttpPKIMessage();
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java b/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java
index 5cf7ecbc234cece70ed2bb4de801729e069e29c9..a54ff500f4808847dedc199d10bcf2b71ec381fa 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java
@@ -120,13 +120,13 @@ public class CRLRepository extends Repository implements ICRLRepository {
     /**
      * Retrieves all issuing points' names
      */
-    public Vector getIssuingPointsNames() throws EBaseException {
+    public Vector<String> getIssuingPointsNames() throws EBaseException {
         IDBSSession s = mDBService.createSession();
         try {
             String[] attrs = { ICRLIssuingPointRecord.ATTR_ID, "objectclass" };
             String filter = "objectclass=" + CMS.getCRLIssuingPointRecordName();
             IDBSearchResults res = s.search(getDN(), filter, attrs);
-            Vector v = new Vector();
+            Vector<String> v = new Vector<String>();
             while (res.hasMoreElements()) {
                 ICRLIssuingPointRecord nextelement =
                         (ICRLIssuingPointRecord) res.nextElement();
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/DBSubsystem.java b/pki/base/common/src/com/netscape/cmscore/dbs/DBSubsystem.java
index be26c036c1d48b87913ffeb2272f3defb592d3bf..4adb17dd868bf12a738f43d208e30722895d9869 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/DBSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/DBSubsystem.java
@@ -74,7 +74,7 @@ public class DBSubsystem implements IDBSubsystem {
     private String mBaseDN = null;
     private ISubsystem mOwner = null;
 
-    private Hashtable[] mRepos = null;
+    private Hashtable<String, String>[] mRepos = null;
 
     private BigInteger mNextSerialConfig = null;
     private boolean mEnableSerialMgmt = false;
@@ -247,7 +247,7 @@ public class DBSubsystem implements IDBSubsystem {
      * @return min serial number
      */
     public String getMinSerialConfig(int repo) {
-        return (String) (mRepos[repo]).get(PROP_MIN);
+        return mRepos[repo].get(PROP_MIN);
     }
 
     /**
@@ -257,7 +257,7 @@ public class DBSubsystem implements IDBSubsystem {
      * @return max serial number
      */
     public String getMaxSerialConfig(int repo) {
-        return (String) (mRepos[repo]).get(PROP_MAX);
+        return mRepos[repo].get(PROP_MAX);
     }
 
     /**
@@ -267,7 +267,7 @@ public class DBSubsystem implements IDBSubsystem {
      * @return min serial number in next range
      */
     public String getNextMinSerialConfig(int repo) {
-        String ret = (String) (mRepos[repo]).get(PROP_NEXT_MIN);
+        String ret = mRepos[repo].get(PROP_NEXT_MIN);
         if (ret.equals("-1")) {
             return null;
         } else {
@@ -282,7 +282,7 @@ public class DBSubsystem implements IDBSubsystem {
      * @return max serial number in next range
      */
     public String getNextMaxSerialConfig(int repo) {
-        String ret = (String) (mRepos[repo]).get(PROP_NEXT_MAX);
+        String ret = mRepos[repo].get(PROP_NEXT_MAX);
         if (ret.equals("-1")) {
             return null;
         } else {
@@ -297,7 +297,7 @@ public class DBSubsystem implements IDBSubsystem {
      * @return low water mark
      */
     public String getLowWaterMarkConfig(int repo) {
-        return (String) (mRepos[repo]).get(PROP_LOW_WATER_MARK);
+        return mRepos[repo].get(PROP_LOW_WATER_MARK);
     }
 
     /**
@@ -307,7 +307,7 @@ public class DBSubsystem implements IDBSubsystem {
      * @return range increment
      */
     public String getIncrementConfig(int repo) {
-        return (String) (mRepos[repo]).get(PROP_INCREMENT);
+        return mRepos[repo].get(PROP_INCREMENT);
     }
 
     /**
@@ -319,7 +319,7 @@ public class DBSubsystem implements IDBSubsystem {
      */
     public void setMaxSerialConfig(int repo, String serial)
             throws EBaseException {
-        Hashtable h = mRepos[repo];
+        Hashtable<String, String> h = mRepos[repo];
         CMS.debug("DBSubsystem: Setting max serial number for " + h.get(NAME) + ": " + serial);
 
         //persist to file
@@ -340,7 +340,7 @@ public class DBSubsystem implements IDBSubsystem {
      */
     public void setMinSerialConfig(int repo, String serial)
             throws EBaseException {
-        Hashtable h = mRepos[repo];
+        Hashtable<String, String> h = mRepos[repo];
         CMS.debug("DBSubsystem: Setting min serial number for " + h.get(NAME) + ": " + serial);
 
         //persist to file
@@ -361,7 +361,7 @@ public class DBSubsystem implements IDBSubsystem {
      */
     public void setNextMaxSerialConfig(int repo, String serial)
             throws EBaseException {
-        Hashtable h = mRepos[repo];
+        Hashtable<String, String> h = mRepos[repo];
         if (serial == null) {
             CMS.debug("DBSubsystem: Removing next max " + h.get(NAME) + " number");
             mDBConfig.remove((String) h.get(PROP_NEXT_MAX_NAME));
@@ -372,7 +372,7 @@ public class DBSubsystem implements IDBSubsystem {
         IConfigStore rootStore = getOwner().getConfigStore();
         rootStore.commit(false);
         if (serial == null) {
-            Object o2 = h.remove(PROP_NEXT_MAX);
+            h.remove(PROP_NEXT_MAX);
         } else {
             h.put(PROP_NEXT_MAX, serial);
         }
@@ -388,7 +388,7 @@ public class DBSubsystem implements IDBSubsystem {
      */
     public void setNextMinSerialConfig(int repo, String serial)
             throws EBaseException {
-        Hashtable h = mRepos[repo];
+        Hashtable<String, String> h = mRepos[repo];
         if (serial == null) {
             CMS.debug("DBSubsystem: Removing next min " + h.get(NAME) + " number");
             mDBConfig.remove((String) h.get(PROP_NEXT_MIN_NAME));
@@ -399,7 +399,7 @@ public class DBSubsystem implements IDBSubsystem {
         IConfigStore rootStore = getOwner().getConfigStore();
         rootStore.commit(false);
         if (serial == null) {
-            Object o2 = h.remove(PROP_NEXT_MIN);
+            h.remove(PROP_NEXT_MIN);
         } else {
             h.put(PROP_NEXT_MIN, serial);
         }
@@ -418,7 +418,7 @@ public class DBSubsystem implements IDBSubsystem {
         LDAPConnection conn = null;
         String nextRange = null;
         try {
-            Hashtable h = mRepos[repo];
+            Hashtable<String, String> h = mRepos[repo];
             conn = mLdapConnFactory.getConn();
             String dn = (String) h.get(PROP_BASEDN) + "," + mBaseDN;
             String rangeDN = (String) h.get(PROP_RANGE_DN) + "," + mBaseDN;
@@ -484,7 +484,7 @@ public class DBSubsystem implements IDBSubsystem {
             if (nextRangeStart == null) {
                 return false;
             }
-            Hashtable h = mRepos[repo];
+            Hashtable<String, String> h = mRepos[repo];
             conn = mLdapConnFactory.getConn();
             String rangedn = (String) h.get(PROP_RANGE_DN) + "," + mBaseDN;
             String filter = "(&(nsds5ReplConflict=*)(objectClass=pkiRange)(host= " +
@@ -546,7 +546,7 @@ public class DBSubsystem implements IDBSubsystem {
             mEnableSerialMgmt = mDBConfig.getBoolean(PROP_ENABLE_SERIAL_MGMT, false);
 
             // populate the certs hash entry
-            Hashtable certs = new Hashtable();
+            Hashtable<String, String> certs = new Hashtable<String, String>();
             certs.put(NAME, "certs");
             certs.put(PROP_BASEDN, mDBConfig.getString(PROP_SERIAL_BASEDN, ""));
             certs.put(PROP_RANGE_DN, mDBConfig.getString(PROP_SERIAL_RANGE_DN, ""));
@@ -578,7 +578,7 @@ public class DBSubsystem implements IDBSubsystem {
             mRepos[CERTS] = certs;
 
             // populate the requests hash entry
-            Hashtable requests = new Hashtable();
+            Hashtable<String, String> requests = new Hashtable<String, String>();
             requests.put(NAME, "requests");
             requests.put(PROP_BASEDN, mDBConfig.getString(PROP_REQUEST_BASEDN, ""));
             requests.put(PROP_RANGE_DN, mDBConfig.getString(PROP_REQUEST_RANGE_DN, ""));
@@ -610,7 +610,7 @@ public class DBSubsystem implements IDBSubsystem {
             mRepos[REQUESTS] = requests;
 
             // populate replica ID hash entry
-            Hashtable replicaID = new Hashtable();
+            Hashtable<String, String> replicaID = new Hashtable<String, String>();
             replicaID.put(NAME, "requests");
             replicaID.put(PROP_BASEDN, mDBConfig.getString(PROP_REPLICA_BASEDN, ""));
             replicaID.put(PROP_RANGE_DN, mDBConfig.getString(PROP_REPLICA_RANGE_DN, ""));
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/RepositoryRecord.java b/pki/base/common/src/com/netscape/cmscore/dbs/RepositoryRecord.java
index 0a79b4b906562f7c748e96e9bca8c3c7a78bd2da..8f90723cd7704a121fd3fd5fec3ce167fd5d9a94 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/RepositoryRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/RepositoryRecord.java
@@ -41,7 +41,7 @@ public class RepositoryRecord implements IRepositoryRecord {
     private BigInteger mSerialNo = null;
     private String mPublishingStatus = null;
 
-    protected static Vector mNames = new Vector();
+    protected static Vector<String> mNames = new Vector<String>();
     static {
         mNames.addElement(IRepositoryRecord.ATTR_SERIALNO);
         mNames.addElement(IRepositoryRecord.ATTR_PUB_STATUS);
@@ -90,11 +90,11 @@ public class RepositoryRecord implements IRepositoryRecord {
     /**
      * Retrieves a list of attribute names.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mNames.elements();
     }
 
-    public Enumeration getSerializableAttrNames() {
+    public Enumeration<String> getSerializableAttrNames() {
         return mNames.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/StringMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/StringMapper.java
index 5edc72669bb11dacd40803e50f485a49a83ea5cd..710a1787573b687f81520a768ec0aaf62effc44c 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/StringMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/StringMapper.java
@@ -39,7 +39,7 @@ import com.netscape.certsrv.dbs.IDBObj;
 public class StringMapper implements IDBAttrMapper {
 
     private String mLdapName = null;
-    private Vector v = new Vector();
+    private Vector<String> v = new Vector<String>();
 
     /**
      * Constructs string mapper.
@@ -52,7 +52,7 @@ public class StringMapper implements IDBAttrMapper {
     /**
      * Retrieves a list of supported ldap attributes.
      */
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return v.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/StringVectorMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/StringVectorMapper.java
index 8fe1b74fac11772cd709f31f108ca312978248b4..7a465231ba9138172624c2369b586c4cda0ac000 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/StringVectorMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/StringVectorMapper.java
@@ -38,7 +38,7 @@ import com.netscape.certsrv.dbs.IDBObj;
 public class StringVectorMapper implements IDBAttrMapper {
 
     private String mLdapName = null;
-    private Vector v = new Vector();
+    private Vector<String> v = new Vector<String>();
 
     /**
      * Constructs string vector mapper.
@@ -51,7 +51,7 @@ public class StringVectorMapper implements IDBAttrMapper {
     /**
      * Retrieves a list of supported ldap attributes.
      */
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return v.elements();
     }
 
@@ -61,7 +61,8 @@ public class StringVectorMapper implements IDBAttrMapper {
     public void mapObjectToLDAPAttributeSet(IDBObj parent,
             String name, Object obj, LDAPAttributeSet attrs)
             throws EBaseException {
-        Vector v = (Vector) obj;
+        @SuppressWarnings("unchecked")
+        Vector<String> v = (Vector<String>) obj;
         int s = v.size();
 
         if (s == 0) {
@@ -70,7 +71,7 @@ public class StringVectorMapper implements IDBAttrMapper {
         String m[] = new String[s];
 
         for (int i = 0; i < s; i++) {
-            m[i] = (String) v.elementAt(i);
+            m[i] = v.elementAt(i);
         }
         attrs.add(new LDAPAttribute(mLdapName, m));
     }
@@ -85,11 +86,12 @@ public class StringVectorMapper implements IDBAttrMapper {
 
         if (attr == null)
             return;
-        Enumeration e = attr.getStringValues();
-        Vector v = new Vector();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = attr.getStringValues();
+        Vector<String> v = new Vector<String>();
 
         while (e.hasMoreElements()) {
-            v.addElement((String) e.nextElement());
+            v.addElement(e.nextElement());
         }
         if (v.size() == 0)
             return;
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/X500NameMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/X500NameMapper.java
index 9d4da6e0f57b412c089858c79b2f27f64e8b02e5..0bf3bf7dafb428ed8af1a9df1e7313baa7f4d796 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/X500NameMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/X500NameMapper.java
@@ -43,7 +43,7 @@ import com.netscape.certsrv.logging.ILogger;
 public class X500NameMapper implements IDBAttrMapper {
 
     private String mLdapName = null;
-    private Vector v = new Vector();
+    private Vector<String> v = new Vector<String>();
 
     private ILogger mLogger = CMS.getLogger();
 
@@ -58,7 +58,7 @@ public class X500NameMapper implements IDBAttrMapper {
     /**
      * Retrieves a list of ldap attributes.
      */
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return v.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/ldap/LdapSimpleExpression.java b/pki/base/common/src/com/netscape/cmscore/ldap/LdapSimpleExpression.java
index c1935cafc225b33105a59fd4f81e8db13d4131f8..0a1dde49f373b65f86321887fcb5d3d2157488a4 100644
--- a/pki/base/common/src/com/netscape/cmscore/ldap/LdapSimpleExpression.java
+++ b/pki/base/common/src/com/netscape/cmscore/ldap/LdapSimpleExpression.java
@@ -167,10 +167,10 @@ public class LdapSimpleExpression implements ILdapExpression {
         return result;
     }
 
-    private boolean matchVector(Vector value)
+    private boolean matchVector(Vector<Object> value)
             throws ELdapException {
         boolean result = false;
-        Enumeration e = (Enumeration) value.elements();
+        Enumeration<Object> e = (Enumeration<Object>) value.elements();
 
         for (; e.hasMoreElements();) {
             result = matchValue(e.nextElement());
@@ -185,13 +185,14 @@ public class LdapSimpleExpression implements ILdapExpression {
         boolean result = false;
 
         for (int i = 0; i < value.length; i++) {
-            result = matchValue((Object) value[i]);
+            result = matchValue(value[i]);
             if (result)
                 break;
         }
         return result;
     }
 
+    @SuppressWarnings("unchecked")
     private boolean matchValue(Object value)
             throws ELdapException {
         boolean result;
@@ -207,7 +208,7 @@ public class LdapSimpleExpression implements ILdapExpression {
         else if (value instanceof Boolean)
             result = matchBooleanValue((Boolean) value);
         else if (value instanceof Vector)
-            result = matchVector((Vector) value);
+            result = matchVector((Vector<Object>) value);
         else if (value instanceof String[])
             result = matchStringArray((String[]) value);
         else
diff --git a/pki/base/common/src/com/netscape/cmscore/policy/SimpleExpression.java b/pki/base/common/src/com/netscape/cmscore/policy/SimpleExpression.java
index acb2c0d6b1b46c58e030562f8128ab312501b886..c844414680157e4cc4144578e810ab105db7cd09 100644
--- a/pki/base/common/src/com/netscape/cmscore/policy/SimpleExpression.java
+++ b/pki/base/common/src/com/netscape/cmscore/policy/SimpleExpression.java
@@ -127,10 +127,10 @@ public class SimpleExpression implements IExpression {
         return matchValue(givenVal);
     }
 
-    private boolean matchVector(Vector value)
+    private boolean matchVector(Vector<?> value)
             throws EPolicyException {
         boolean result = false;
-        Enumeration e = (Enumeration) value.elements();
+        Enumeration<?> e = (Enumeration<?>) value.elements();
 
         for (; e.hasMoreElements();) {
             result = matchValue(e.nextElement());
@@ -168,7 +168,7 @@ public class SimpleExpression implements IExpression {
         else if (value instanceof Boolean)
             result = matchBooleanValue((Boolean) value);
         else if (value instanceof Vector)
-            result = matchVector((Vector) value);
+            result = matchVector((Vector<?>) value);
         else if (value instanceof String[])
             result = matchStringArray((String[]) value);
         else
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
index 82739debf8db57044bd70a8760520f02b2097742..6a5cb1abcd2625e8d0fe8da66f8bdf155912995c 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
@@ -928,6 +928,7 @@ class Request
         return (String) value;
     }
 
+    @SuppressWarnings("unchecked")
     public Hashtable<String, String> getExtDataInHashtable(String key) {
         Object value = mExtData.get(key);
         if (value == null) {
